import java.util.*;

class SemaphoreStrong implements Semaphore {
    public synchronized void up()
    {   if (blocked.isEmpty()) count = count + 1;
        else notifyAll();    } // wake up all waiting threads

    public synchronized void down() throws InterruptedException
    {   Thread me = Thread.currentThread();
        blocked.add(me);  // enqueue me
        while (count == 0 || blocked.element() != me)
            wait();         // I'm enqueued when suspending
        // now count > 0 and it's my turn: dequeue me and decrement
        blocked.remove();  count = count - 1;   }

    private final Queue<Thread> blocked = new LinkedList<>();

    private int count;

    public synchronized int count() {
        return count;
    }

    SemaphoreStrong(int capacity) {
        count = capacity;
    }
}
